//+------------------------------------------------------------------+
//|                                                        Pivot.mq4 |
//+------------------------------------------------------------------+
 

#property indicator_chart_window
//#property indicator_separate_window
//#property indicator_buffers 1

extern color LabelColor = Blue;

extern color PivotColor = Blue;
extern int PivotStyle =  STYLE_SOLID;  

extern color R1Color = Green;
extern int R1Style  = STYLE_SOLID;  
extern color R2Color = Green;
extern int R2Style  = STYLE_SOLID; 
extern color R3Color = Green;
extern int R3Style  = STYLE_SOLID; 


extern color S1Color = Red;
extern int S1Style  = STYLE_SOLID;  
extern color S2Color = Red;
extern int S2Style  = STYLE_SOLID; 
extern color S3Color = Red;
extern int S3Style  = STYLE_SOLID; 

 
//---- input parameters

extern bool Zero = true;
extern bool One = true;
extern bool Two = true;
extern bool Three = true;

extern string  TimePeriod="D1";

extern int Type = 1;

//---- buffers
 datetime time1;
   datetime time2;
   double open,close,high,low;
string Pivot = "Pivot Point", Sup1 = "S 1", Res1 = "R 1";
string Sup2="S 2", Res2="R 2", Sup3="S 3", Res3="R 3";
int fontsize = 10;
double P, S1, R1, S2, R2, S3, R3,period;
double LastHigh, LastLow, x,num;
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   //ObjDel( );
  // ObjectsTotal()
ObjectsDeleteAll(); 
      
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+


   void PlotLine(string name,double value,double line_color,double style)
   {
   ObjectCreate(name,OBJ_TREND,0,time1,value,time2,value);
   ObjectSet(name, OBJPROP_WIDTH, 1);
   ObjectSet(name, OBJPROP_STYLE, style);
   ObjectSet(name, OBJPROP_RAY, false);
   ObjectSet(name, OBJPROP_BACK, true);
   ObjectSet(name, OBJPROP_COLOR, line_color);
    }   
  void ObjDel()
   {
       
	//ObjectsDeleteAll(); 
	

	 for (num=1;num<=10000;num++)
      {
      ObjectDelete("PP["+num+"]");
      ObjectDelete("R1["+num+"]");
      ObjectDelete("R2["+num+"]");
      ObjectDelete("R3["+num+"]");
      ObjectDelete("S1["+num+"]");
      ObjectDelete("S2["+num+"]");
      ObjectDelete("S3["+num+"]"); 
	  }
}	  
  
int init()
  {
//---- indicator line

   ObjectsDeleteAll(); 
   
   if (TimePeriod=="M1" || TimePeriod=="1") period=PERIOD_M1;
   else
   if (TimePeriod=="M5" || TimePeriod=="5") period=PERIOD_M5;
   else
   if (TimePeriod=="M15" || TimePeriod=="15") period=PERIOD_M15;
   else
   if (TimePeriod=="M30" || TimePeriod=="30") period=PERIOD_M30;
   else
   if (TimePeriod=="H1" || TimePeriod=="60") period=PERIOD_H1;
   else
   if (TimePeriod=="H4" || TimePeriod=="240") period=PERIOD_H4;
   else 
   if (TimePeriod=="D1" || TimePeriod=="1440") period=PERIOD_D1;
   else
   if (TimePeriod=="W1" || TimePeriod=="10080") period=PERIOD_W1; 
   else
   if (TimePeriod=="MN" || TimePeriod=="43200") period=PERIOD_MN1;
   else

   {
   Comment("Wrong TimePeriod. Must be M5, M15, M30, H1, H4, D1, W1 or MN"); 
  
   }
   
   
     if (Type==1 || Type==2|| Type==3|| Type==4|| Type==5|| Type==6)
	 {
	 }
   else
   {
   Comment("Wrong TimePeriod. Must be 1 for Pivot,  2 for Camarilla, 3 for Woodie, 4 for Fibonacci, 5 for Floor,  or 6 For Fibonacci Retracement"); 
   
   }
  
 
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Pivot Point");
   SetIndexLabel(0, "Pivot Point");
//----
   SetIndexDrawBegin(0,1);
//----
   return(0);
  }

 
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
    
  {
   
   int counted_bars = IndicatorCounted();
   
   if (period <= Period()) 
   {
   ObjectsDeleteAll(); 
   return (0);
   }
   

   int limit, i;
//---- indicator calculation
   if(counted_bars == 0)
     {
       //x = Period();
      
		   
		 if (Zero)
       {   
       ObjectCreate("Pivot", OBJ_TEXT, 0, 0, 0);
	          ObjectSetText("Pivot", "                 Pivot Point", fontsize, "Arial", LabelColor);

	   }
	    if (One)
       {
       ObjectCreate("Sup1", OBJ_TEXT, 0, 0, 0);
       ObjectSetText("Sup1", "      S 1", fontsize, "Arial", LabelColor);
       ObjectCreate("Res1", OBJ_TEXT, 0, 0, 0);
       ObjectSetText("Res1", "      R 1", fontsize, "Arial", LabelColor);
	   }
	   
	   
	    if (Two)
       {
       ObjectCreate("Sup2", OBJ_TEXT, 0, 0, 0);
       ObjectSetText("Sup2", "      S 2", fontsize, "Arial", LabelColor);
       ObjectCreate("Res2", OBJ_TEXT, 0, 0, 0);
       ObjectSetText("Res2", "      R 2", fontsize, "Arial", LabelColor);
	   }
	    if (Three)
      {
       ObjectCreate("Sup3", OBJ_TEXT, 0, 0, 0);
       ObjectSetText("Sup3", "      S 3", fontsize, "Arial", LabelColor);
       ObjectCreate("Res3", OBJ_TEXT, 0, 0, 0);
       ObjectSetText("Res3", "      R 3", fontsize, "Arial", LabelColor);
	   }
     }
   if(counted_bars < 0) 
       return(-1);
   //---- last counted bar will be recounted
   //   if(counted_bars>0) counted_bars--;
   limit = (Bars - counted_bars) - 1;
//----

 ObjDel();
   for(i = limit; i >= 0; i--)
     { 
       int Delta =iTime(NULL,period,i)-iTime(NULL,period,i+1);
	    time1=iTime(NULL,period,i);  
        time2=time1+Delta;   		
		//time2=time1+period*60;
		 
             
		  high  = iHigh(NULL,period,i+1);
		  low   = iLow(NULL,period,i+1);
		  open  = iOpen(NULL,period,i+1);
		  close = iClose(NULL,period,i+1);
		  
//1 for Pivot,  2 for Camarilla, 3 for Woodie, 4 for Fibonacci, 5 for Floor,  or 6 For Fibonacci Retracement
	      //1 for Pivot;
		  if ( Type == 1  ) 
		  {
           P = (high + low + close ) / 3;
           R1 = (2*P) - low;
           S1 = (2*P) - high;
           R2 = P + (high - low);
           S2 = P - (high - low);
           R3 = (P) + (high - low)*2;
           S3 = (P) -  (high - low)*2;		 
		   
		   }
		  // 2 for Camarilla;
		     if ( Type == 2  ) 
		  {
            P = close;
            R1 = P + (high - low)* 1.1 / 12;
           S1 = P - (high - low)* 1.1 / 12;
		   
           R2 = P + (high - low) * 1.1 / 6;
           S2 = P - (high - low) * 1.1 / 6;
		   
           R3 =P + (high - low)* 1.1 / 4;
           S3 =P - (high - low)* 1.1 / 4;	 
		   }
		   // 3 for Woodie; 
		     if ( Type == 3  ) 
		  {
          
          	 P=open;
			 
			 
			R1 =P*2-low;
           S1 = P*2-high;
		   
           R2 = P + (high - low) ;
           S2 = P - (high - low);
		   
           R3 = high + 2 *(P-low) ;
           S3 = low - 2 *(high-P) ;
		   
		   }
         // 4 for Fibonacci;
		     if ( Type == 4  ) 
		  {
           P = (high + low + close ) / 3;
		   
		   
           	R1 = P+ 0.382 * (high - low);
           S1 =  P- 0.382 * (high - low);
		   
           R2 =  P+ 0.618 *(high - low);
           S2 = P - 0.618 *(high - low);
		   
           R3 = P+ (high - low);
           S3 =  P- (high - low);
		   }
		   
		   //5 for Floor;
		     if ( Type == 5  ) 
		  {
            
         	P = (high + low + close ) / 3; 
			
			R1 = P*2+ low;
           S1 =  high;
		   
           R2 =  P+(high - low);
           S2 = P -(high - low);
		   
           R3 = high+ (P - low)*2;
           S3 =  low - (high - P)*2;
		   
		   }
		   
		   //6 For Fibonacci Retracement 
		     if ( Type == 6  ) 
		  {
             P = (high + low)/2;
			 
            R1 = low+(high - low)*0.618 ;
           S1 = low+(high - low)*0.382;
		   
           R2 =  low+(high - low)*0.764 ;
           S2 = low+(high - low)*0.236;
		   
           R3 = low+(high - low)*1;
           S3 = low+(high - low)*0;
		   }
           
           //----
           ObjectMove("Pivot", 0, Time[i], P);
           ObjectMove("Sup1", 0, Time[i], S1);
           ObjectMove("Res1", 0, Time[i], R1);
           ObjectMove("Sup2", 0, Time[i], S2);
           ObjectMove("Res2", 0, Time[i], R2);
           ObjectMove("Sup3", 0, Time[i], S3);
           ObjectMove("Res3", 0, Time[i], R3);	
		  
			
  if (Zero)
  {
  PlotLine("PP["+i+"]",P,PivotColor,PivotStyle);
  
  }
  if (One)
  {
   PlotLine("R1["+i+"]",R1,R1Color,R1Style);
   PlotLine("S1["+i+"]",S1,S1Color,S1Style);
   }
   
  if (Two)
  {
  PlotLine("R2["+i+"]",R2,R2Color,R2Style);
   PlotLine("S2["+i+"]",S2,S2Color,S2Style);
   }
   
   if (Three)
   {
    PlotLine("R3["+i+"]",R3,R3Color,R3Style);
   PlotLine("S3["+i+"]",S3,S3Color,S3Style);
   }
   
       		   
           
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+